%prefix calc_%

%{
#include <stdio.h>
#include "calc.h"
%}

%start list

%struct
{
	int line, first_col, last_col;
}

%union
{
	double d;
	int i;
}

%token NUMBER LETTER

%left '|'
%left '&'
%left '+' '-'
%left '*' '/' '%'
%left UMINUS   /* supplies precedence for unary minus */

%type <i> LETTER
%type <d> NUMBER
%type <d> expr

%% /* beginning of rules section */

list  :  /* empty */
      |  list stat '\n'
      |  list error '\n'
            {  calc_errok ; }
      ;

stat  :  expr
            {  printf("%f\n",$1);}
      |  LETTER '=' expr
            {  ctx->regs[$1] = $3; }
      ;

expr  :  '(' expr ')'
            {  $$ = $2; }
      |  expr '+' expr
            {  $$ = $1 + $3; }
      |  expr '-' expr
            {  $$ = $1 - $3; }
      |  expr '*' expr
            {  $$ = $1 * $3; }
      |  expr '/' expr
            {  $$ = $1 / $3; }
      |  '-' expr %prec UMINUS
            {  $$ = - $2; }
      |  LETTER
            {  $$ = ctx->regs[$1]; }
      |  NUMBER
            { $$ = $1; }
      ;


%%
