#include <stdio.h>
#include <string.h>
#include "calc.h"
#include "gram.h"
#include "lex.h"

int main(void)
{
	calc_ctx_t ctx;
	calc_yyctx_t yyctx;

	memset(&ctx, 0, sizeof(ctx));

	if (calc_parse_init(&yyctx) != 0)
		return -1;

	for(;;) {
		int tok, res;
		calc_STYPE lval;

		if (feof(stdin)) {
			printf("<feof>\n");
			break;
		}
		tok = calc_lex(&ctx, &lval);
		res = calc_parse(&yyctx, &ctx, tok, &lval);
	}
	return 0;
}

void calc_error(calc_ctx_t *ctx, calc_STYPE tok, const char *s)
{
	fprintf(stderr, "%s at %d:%d..%d\n", s, tok.line+1, tok.first_col, tok.last_col);
}

