#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "lex.h"

/* lexical analysis routine
   returns LETTER for a lower case letter, .i = 0 through 25
   return NUMBER for a for numbers, converted double in .d
   all other characters are returned immediately */
int calc_lex(calc_ctx_t *ctx, calc_STYPE *yylval)
{
	int c, n;
	char buf[128];
	while((c=getchar()) == ' ') ; /* skip blanks */

	/* c is now nonblank */
	if (islower(c)) {
		yylval->i = c - 'a';
		return LETTER;
	}

	/* collect numbers in tmp[] and use strtod() to convert them */
	if (isdigit(c) || (c == '.')) {
		int seen_e = 0, seen_esign = 0, seen_dot = 0;
		buf[0] = c;
		for(n = 1; n < sizeof(buf)-1; n++) {
			c = getchar();
			if (c == '.') {
				if (seen_dot)
					break;
				seen_dot = 1;
			}
			if ((c == 'e') || (c == 'E')) {
				if (seen_e)
					break;
				seen_e = 1;
			}
			if ((c == '+') || (c == '-')) {
				if ((!seen_e) || (seen_esign))
					break;
				seen_esign = 1;
			}
			if (isdigit(c) || (c == '+') || (c == '-') || (c == 'e') || (c == 'E') || (c == '.'))
				buf[n] = c;
			else
				break;
		}
		ungetc(c, stdin);
		buf[n] = '\0';
		yylval->d = strtod(buf, NULL);
		return NUMBER;
	}
	return c;
}


