/* This file generated automatically using
 * 
 */

#include "defs.h"

/*  byaccic bt skel */
/*  If the skeleton is changed, the banner should be changed so that   */
/*  the altered version can be easily distinguished from the original. */
/*                                                                     */
/*  The #defines included with the banner are there because they are   */
/*  useful in subsequent code.  The macros #defined in the header or   */
/*  the body either are not useful outside of semantic actions or      */
/*  are conditional.                                                   */

const char *const banner[] =
{
    "",
"#ifdef YY_QUERY_API_VER"
,"#define YY_BYACCIC"
,    CONCAT1("#define YY_API_MAJOR ", YY_API_MAJOR),
    CONCAT1("#define YY_API_MINOR ", YY_API_MINOR),
"#endif /*YY_QUERY_API_VER*/",
    "",
    "#define `EMPTY`        (-1)",
    "#define `clearin`      (`chr` = `EMPTY`)",
    "#define `errok`        (`errflag` = 0)",
    "#define `RECOVERING`() (`errflag` != 0)",
    "#define `ENOMEM`       (-2)",
    "#define `EOF`          0",
    0
};

const char *const xdecls[] =
{
    "",
    0
};

const char *const tables[] =
{
    "`extern` const `int_t` `lhs`[];",
    "`extern` const `int_t` `len`[];",
    "`extern` const `int_t` `defred`[];",
    "`extern` const `int_t` yystos[];",
    "`extern` const `int_t` `dgoto`[];",
    "`extern` const `int_t` `sindex`[];",
    "`extern` const `int_t` `rindex`[];",
#if defined(YYBTYACC)
    "#if YYBTYACC",
    "`extern` const `int_t` yycindex[];",
    "#endif /* YYBTYACC */",
#endif			/* defined(YYBTYACC) */
    "`extern` const `int_t` `gindex`[];",
    "`extern` const `int_t` `table`[];",
    "`extern` const `int_t` `check`[];",
#if defined(YYBTYACC)
    "#if YYBTYACC",
    "`extern` const `int_t` yyctable[];",
    "#endif /* YYBTYACC */",
#endif			/* defined(YYBTYACC) */
    "",
    "#if `DEBUG` || defined(yytname)",
    "`extern` const char *const `name`[];",
    "#endif",
    "#if `DEBUG`",
    "`extern` const char *const `rule`[];",
    "#endif",
    0
};

const char *const global_vars[] =
{
    "",
    "",
    0
};

const char *const hdr_defs[] =
{
    "",
#if defined(YYBTYACC)
    "#if YYBTYACC",
    "",
    "#ifndef YYLVQUEUEGROWTH",
    "#define YYLVQUEUEGROWTH 32",
    "#endif",
    "#endif /* YYBTYACC */",
#endif			/* defined(YYBTYACC) */
    "",
    "#ifndef `INITSTACKSIZE`",
    "#define `INITSTACKSIZE` 200",
    "#endif",
    "",
    "typedef struct {",
    "	unsigned stacksize;",
    "	`int_t` *s_base;",
    "	`int_t` *s_mark;",
    "	`int_t` *s_last;",
    "	`STYPE` *l_base;",
    "	`STYPE` *l_mark;",
    "} `STACKDATA`;",
    "",
    "typedef struct `yyctx_s` {",
    "	struct yyctx_s *save;	/* Previously saved parser state */",
    "	`STACKDATA` stack;	/* saved parser stack */",
    "	int state;	/* saved parser state */",
    "	int errflag;	/* saved error recovery status */",
    "	int lexeme;	/* saved index of the conflict lexeme in the lexical queue */",
    "	`int_t` ctry;	/* saved index in yyctable[] for this conflict */",
    "",
    "	int chr;",
    "	int jump;",
    "	`STYPE` val;",
    "	`STYPE` lval;",
    "	int nerrs;",
    "	int yyn, yym;",
    "	int stack_max_depth;",
    "#if `DEBUG`",
    "	int `debug`;",
    "#endif",
    "} `yyctx_t`;",
    "",
    "typedef enum { `RES_NEXT`, `RES_DONE`, `RES_ABORT`, `RES_NOMEM` } `res_t`;",
    "",
    "`extern` int `parse_init`(`yyctx_t` *yyctx);",
    "`extern` `res_t` `parse`(`yyctx_t` *yyctx, `ctx_t` *ctx, int tok, `STYPE` *lval);",
    "`extern` void `error`(`ctx_t` *ctx, `STYPE` tok, const char *msg);",
    "",
    0
};

const char *const body_1[] =
{
    "",
    "/* For use in generated program */",
    "#define yydepth (int)(`stack`.s_mark - `stack`.s_base)",
#if defined(YYBTYACC)
    "#if YYBTYACC",
    "#define yytrial (yyps->save)",
    "#endif /* YYBTYACC */",
#endif			/* defined(YYBTYACC) */
    "",
    "#if `DEBUG`",
    "#include <stdio.h>	/* needed for printf */",
    "#endif",
    "",
    "#include <stdlib.h>	/* needed for malloc, etc */",
    "#include <string.h>	/* needed for memset */",
    "",
    "/* allocate initial stack or double stack size, up to yyctx->stack_max_depth */",
    "static int `growstack`(`yyctx_t` *yyctx, `STACKDATA` * data)",
    "{",
    "	int i;",
    "	unsigned newsize;",
    "	`int_t` *newss;",
    "	`STYPE` *newvs;",
    "",
    "	if ((newsize = data->stacksize) == 0)",
    "		newsize = `INITSTACKSIZE`;",
    "	else if (newsize >= yyctx->stack_max_depth)",
    "		return `ENOMEM`;",
    "	else if ((newsize *= 2) > yyctx->stack_max_depth)",
    "		newsize = yyctx->stack_max_depth;",
    "",
    "	i = (int)(data->s_mark - data->s_base);",
    "	newss = (`int_t` *) realloc(data->s_base, newsize * sizeof(*newss));",
    "	if (newss == 0)",
    "		return `ENOMEM`;",
    "",
    "	data->s_base = newss;",
    "	data->s_mark = newss + i;",
    "",
    "	newvs = (`STYPE` *) realloc(data->l_base, newsize * sizeof(*newvs));",
    "	if (newvs == 0)",
    "		return `ENOMEM`;",
    "",
    "	data->l_base = newvs;",
    "	data->l_mark = newvs + i;",
    "",
    "	data->stacksize = newsize;",
    "	data->s_last = data->s_base + newsize - 1;",
    "",
    "#if `DEBUG`",
    "	if (`debug`)",
    "		fprintf(stderr, \"`debug`: stack size increased to %d\\n\", newsize);",
    "#endif",
    "	return 0;",
    "}",
    "",
    "static void `freestack`(`STACKDATA` * data)",
    "{",
    "	free(data->s_base);",
    "	free(data->l_base);",
    "	memset(data, 0, sizeof(*data));",
    "}",
    "",
#if defined(YYBTYACC)
    "#if YYBTYACC",
    "",
    "static yyctx_t *yyNewState(unsigned size)",
    "{",
    "	yyctx_t *p = (yyctx_t *) malloc(sizeof(yyctx_t));",
    "	if (p == NULL)",
    "		return NULL;",
    "",
    "	p->`stack`.stacksize = size;",
    "	if (size == 0) {",
    "		p->`stack`.s_base = NULL;",
    "		p->`stack`.l_base = NULL;",
    "		return p;",
    "	}",
    "	p->`stack`.s_base = (`int_t` *) malloc(size * sizeof(`int_t`));",
    "	if (p->`stack`.s_base == NULL)",
    "		return NULL;",
    "	p->`stack`.l_base = (`STYPE` *) malloc(size * sizeof(`STYPE`));",
    "	if (p->`stack`.l_base == NULL)",
    "		return NULL;",
    "	memset(p->`stack`.l_base, 0, size * sizeof(`STYPE`));",
    "",
    "	return p;",
    "}",
    "",
    "static void yyFreeState(yyctx_t * p)",
    "{",
    "	`freestack`(&p->`stack`);",
    "	free(p);",
    "}",
    "",
    "#endif /* YYBTYACC */",
#endif			/* defined(YYBTYACC) */
    "",
    "#define `ABORT`  goto yyabort",
    "#define `REJECT` goto yyabort",
    "#define `ACCEPT` goto yyaccept",
    "#define `ERROR`  goto yyerrlab",
#if defined(YYBTYACC)
    "#if YYBTYACC",
    "#define `VALID`        do { if (yyps->save)            goto yyvalid; } while(0)",
    "#define `VALID_NESTED` do { if (yyps->save && \\",
    "                                yyps->save->save == 0) goto yyvalid; } while(0)",
    "#endif /* YYBTYACC */",
#endif			/* defined(YYBTYACC) */
    "",
    "int `parse_init`(`yyctx_t` *yyctx)",
    "{",
    "#if `DEBUG`",
    "	const char *yys;",
    "",
    "	if ((yys = getenv(\"`DEBUG`\")) != 0) {",
    "		`yyn` = *yys;",
    "		if (`yyn` >= '0' && `yyn` <= '9')",
    "			`debug` = `yyn` - '0';",
    "	}",
    "	if (`debug`)",
    "		fprintf(stderr, \"`debug`[<# of symbols on state stack>]\\n\");",
    "#endif",
    "",
    "	`errflag` = 0;",
    "	`chr` = 0;",
    "	memset(&`val`, 0, sizeof(`val`));",
    "	memset(&`lval`, 0, sizeof(`lval`));",
    "",
#if defined(YYBTYACC)
    "#if YYBTYACC",
    "	yyps = yyNewState(0);",
    "	if (yyps == 0)",
    "		return -1;",
    "	yyps->save = 0;",
    "#endif /* YYBTYACC */",
#endif			/* defined(YYBTYACC) */
    "	`yym` = 0;",
    "	`yyn` = 0;",
    "	`nerrs` = 0;",
    "	`errflag` = 0;",
    "	`chr` = `EMPTY`;",
    "	`state` = 0;",
    "",
    "	memset(&`stack`, 0, sizeof(`stack`));",
    "",
    "	yyctx->stack_max_depth = `INITSTACKSIZE` > 10000 ? `INITSTACKSIZE` : 10000;",
    "	if (`stack`.s_base == NULL && `growstack`(yyctx, &`stack`) == `ENOMEM`)",
    "		return -1;",
    "	`stack`.s_mark = `stack`.s_base;",
    "	`stack`.l_mark = `stack`.l_base;",
    "	`state` = 0;",
    "	*`stack`.s_mark = 0;",
    "	`jump` = 0;",
    "	return 0;",
    "}",
    "",
    "#define `GETCHAR`(labidx, dst_tok) \\",
    "do { \\",
    "	if (used)               { `jump` = labidx; return `RES_NEXT`; } \\",
    "	getchar_ ## labidx:;    dst_tok = tok; `lval` = *lval; used = 1; \\",
    "} while(0)",
    "",
    "`res_t` `parse`(`yyctx_t` *yyctx, `ctx_t` *ctx, int tok, `STYPE` *lval)",
    "{",
    "	int used = 0;",
    "#if `DEBUG`",
    "	const char *yys;",
    "#endif",
    "/* TODO: body_vars */",
#if defined(YYBTYACC)
    "#if YYBTYACC",
    "",
    "	/* Current parser state */",
    "	static yyctx_t *yyps = 0;",
    "",
    "	/* yypath != NULL: do the full parse, starting at *yypath parser state. */",
    "	static yyctx_t *yypath = 0;",
    "",
    "	/* Base of the lexical value queue */",
    "	static `STYPE` *yylvals = 0;",
    "",
    "	/* Current position at lexical value queue */",
    "	static `STYPE` *yylvp = 0;",
    "",
    "	/* End position of lexical value queue */",
    "	static `STYPE` *yylve = 0;",
    "",
    "	/* The last allocated position at the lexical value queue */",
    "	static `STYPE` *yylvlim = 0;",
    "",
    "	/* Current position at lexical token queue */",
    "	static `int_t` *yylexp = 0;",
    "",
    "	static `int_t` *yylexemes = 0;",
    "#endif /* YYBTYACC */",
#endif			/* defined(YYBTYACC) */
    "",
    "	int yyresult;",
#if defined(YYBTYACC)
    "#if YYBTYACC",
    "	int yynewerrflag;",
    "	yyctx_t *yyerrctx = NULL;",
    "#endif /* YYBTYACC */",
#endif			/* defined(YYBTYACC) */
    "",
    "",
    0
};

const char *const body_3[] =
{
    "",
    "yyloop:",
#if defined(YYBTYACC)
    "#if YYBTYACC",
    "	if (`jump` == 1) { `jump` = 0; goto getchar_1; }",
    "	if (`jump` == 3) { `jump` = 0; goto getchar_3; }",
    "#endif /* YYBTYACC */",
#endif			/* defined(YYBTYACC) */
    "	if (`jump` == 2) { `jump` = 0; goto getchar_2; }",
    "	if (`jump` == 4) { `jump` = 0; goto getchar_4; }",
    "",
    "	if ((`yyn` = `defred`[`state`]) != 0)",
    "		goto yyreduce;",
    "	if (`chr` < 0) {",
#if defined(YYBTYACC)
    "#if YYBTYACC",
    "		do {",
    "			if (yylvp < yylve) {",
    "				/* we're currently re-reading tokens */",
    "				`lval` = *yylvp++;",
    "				`chr` = *yylexp++;",
    "				break;",
    "			}",
    "			if (yyps->save) {",
    "				/* in trial mode; save scanner results for future parse attempts */",
    "				if (yylvp == yylvlim) {	/* Enlarge lexical value queue */",
    "					size_t p = (size_t)(yylvp - yylvals);",
    "					size_t s = (size_t)(yylvlim - yylvals);",
    "",
    "					s += YYLVQUEUEGROWTH;",
    "					if ((yylexemes = (`int_t` *) realloc(yylexemes, s * sizeof(`int_t`))) == NULL)",
    "						goto `ENOMEM`;",
    "					if ((yylvals = (`STYPE` *) realloc(yylvals, s * sizeof(`STYPE`))) == NULL)",
    "						goto `ENOMEM`;",
    "					yylvp = yylve = yylvals + p;",
    "					yylvlim = yylvals + s;",
    "					yylexp = yylexemes + p;",
    "				}",
    "				`GETCHAR`(1, *yylexp);",
    "				*yylvp++ = `lval`;",
    "				yylve++;",
    "				`chr` = *yylexp++;",
    "				break;",
    "			}",
    "			/* normal operation, no conflict encountered */",
    "#endif /* YYBTYACC */",
#endif			/* defined(YYBTYACC) */
    "			`GETCHAR`(2, `chr`);",
#if defined(YYBTYACC)
    "#if YYBTYACC",
    "		} while(0);",
    "#endif /* YYBTYACC */",
#endif			/* defined(YYBTYACC) */
    "		if (`chr` < 0)",
    "			`chr` = `EOF`;",
    "#if `DEBUG`",
    "		if (`debug`) {",
    "			if ((yys = `name`[`TRANSLATE`(`chr`)]) == NULL)",
    "				yys = `name`[`UNDFTOKEN`];",
    "			fprintf(stderr, \"%s[%d]: state %d, reading token %d (%s)\", YYDEBUGSTR, yydepth, `state`, `chr`, yys);",
    "#ifdef `STYPE`_TOSTRING",
#if defined(YYBTYACC)
    "#if YYBTYACC",
    "			if (!yytrial)",
    "#endif /* YYBTYACC */",
#endif			/* defined(YYBTYACC) */
    "				fprintf(stderr, \" <%s>\", `STYPE`_TOSTRING(`chr`, `lval`));",
    "#endif",
    "			fputc('\\n', stderr);",
    "		}",
    "#endif",
    "	}",
#if defined(YYBTYACC)
    "#if YYBTYACC",
    "",
    "	/* Do we have a conflict? */",
    "	if (((`yyn` = yycindex[`state`]) != 0) && (`yyn` += `chr`) >= 0 && `yyn` <= `TABLESIZE` && `check`[`yyn`] == (`int_t`) `chr`) {",
    "		`int_t` ctry;",
    "",
    "		if (yypath) {",
    "			yyctx_t *save;",
    "#if `DEBUG`",
    "			if (`debug`)",
    "				fprintf(stderr, \"%s[%d]: CONFLICT in state %d: following successful trial parse\\n\", YYDEBUGSTR, yydepth, `state`);",
    "#endif",
    "			/* Switch to the next conflict context */",
    "			save = yypath;",
    "			yypath = save->save;",
    "			save->save = NULL;",
    "			ctry = save->ctry;",
    "			if (save->state != `state`)",
    "				YYABORT;",
    "			yyFreeState(save);",
    "",
    "		}",
    "		else {",
    "",
    "			/* Unresolved conflict - start/continue trial parse */",
    "			yyctx_t *save;",
    "#if `DEBUG`",
    "			if (`debug`) {",
    "				fprintf(stderr, \"%s[%d]: CONFLICT in state %d. \", YYDEBUGSTR, yydepth, `state`);",
    "				if (yyps->save)",
    "					fputs(\"ALREADY in conflict, continuing trial parse.\\n\", stderr);",
    "				else",
    "					fputs(\"Starting trial parse.\\n\", stderr);",
    "			}",
    "#endif",
    "			save = yyNewState((unsigned)(`stack`.s_mark - `stack`.s_base + 1));",
    "			if (save == NULL)",
    "				goto `ENOMEM`;",
    "			save->save = yyps->save;",
    "			save->state = `state`;",
    "			save->errflag = `errflag`;",
    "			save->`stack`.s_mark = save->`stack`.s_base + (`stack`.s_mark - `stack`.s_base);",
    "			memcpy(save->`stack`.s_base, `stack`.s_base, (size_t)(`stack`.s_mark - `stack`.s_base + 1) * sizeof(`int_t`));",
    "			save->`stack`.l_mark = save->`stack`.l_base + (`stack`.l_mark - `stack`.l_base);",
    "			memcpy(save->`stack`.l_base, `stack`.l_base, (size_t)(`stack`.l_mark - `stack`.l_base + 1) * sizeof(`STYPE`));",
    "			ctry = `table`[`yyn`];",
    "			if (yyctable[ctry] == -1) {",
    "#if `DEBUG`",
    "				if (`debug` && `chr` >= `EOF`)",
    "					fprintf(stderr, \"%s[%d]: backtracking 1 token\\n\", YYDEBUGSTR, yydepth);",
    "#endif",
    "				ctry++;",
    "			}",
    "			save->ctry = ctry;",
    "			if (yyps->save == NULL) {",
    "				/* If this is a first conflict in the stack, start saving lexemes */",
    "				if (!yylexemes) {",
    "					yylexemes = (`int_t` *) malloc((YYLVQUEUEGROWTH) * sizeof(`int_t`));",
    "					if (yylexemes == NULL)",
    "						goto `ENOMEM`;",
    "					yylvals = (`STYPE` *) malloc((YYLVQUEUEGROWTH) * sizeof(`STYPE`));",
    "					if (yylvals == NULL)",
    "						goto `ENOMEM`;",
    "					yylvlim = yylvals + YYLVQUEUEGROWTH;",
    "				}",
    "				if (yylvp == yylve) {",
    "					yylvp = yylve = yylvals;",
    "					yylexp = yylexemes;",
    "					if (`chr` >= `EOF`) {",
    "						*yylve++ = `lval`;",
    "						*yylexp = (`int_t`) `chr`;",
    "						`chr` = `EMPTY`;",
    "					}",
    "				}",
    "			}",
    "			if (`chr` >= `EOF`) {",
    "				yylvp--;",
    "				yylexp--;",
    "				`chr` = `EMPTY`;",
    "			}",
    "			save->lexeme = (int)(yylvp - yylvals);",
    "			yyps->save = save;",
    "		}",
    "		if (`table`[`yyn`] == ctry) {",
    "#if `DEBUG`",
    "			if (`debug`)",
    "				fprintf(stderr, \"%s[%d]: state %d, shifting to state %d\\n\", YYDEBUGSTR, yydepth, `state`, yyctable[ctry]);",
    "#endif",
    "			if (`chr` < 0) {",
    "				yylvp++;",
    "				yylexp++;",
    "			}",
    "			if (`stack`.s_mark >= `stack`.s_last && `growstack`(yyctx, &`stack`) == `ENOMEM`)",
    "				goto yyoverflow;",
    "			`state` = yyctable[ctry];",
    "			*++`stack`.s_mark = (`int_t`) `state`;",
    "			*++`stack`.l_mark = `lval`;",
    "			`chr` = `EMPTY`;",
    "			if (`errflag` > 0)",
    "				--`errflag`;",
    "			goto yyloop;",
    "		}",
    "		else {",
    "			`yyn` = yyctable[ctry];",
    "			goto yyreduce;",
    "		}",
    "	}	/* End of code dealing with conflicts */",
    "#endif /* YYBTYACC */",
#endif			/* defined(YYBTYACC) */
    "	if (((`yyn` = `sindex`[`state`]) != 0) && (`yyn` += `chr`) >= 0 && `yyn` <= `TABLESIZE` && `check`[`yyn`] == (`int_t`) `chr`) {",
    "#if `DEBUG`",
    "		if (`debug`)",
    "			fprintf(stderr, \"%s[%d]: state %d, shifting to state %d\\n\", YYDEBUGSTR, yydepth, `state`, `table`[`yyn`]);",
    "#endif",
    "		if (`stack`.s_mark >= `stack`.s_last && `growstack`(yyctx, &`stack`) == `ENOMEM`)",
    "			goto yyoverflow;",
    "		`state` = `table`[`yyn`];",
    "		*++`stack`.s_mark = `table`[`yyn`];",
    "		*++`stack`.l_mark = `lval`;",
    "		`chr` = `EMPTY`;",
    "		if (`errflag` > 0)",
    "			--`errflag`;",
    "		goto yyloop;",
    "	}",
    "	if (((`yyn` = `rindex`[`state`]) != 0) && (`yyn` += `chr`) >= 0 && `yyn` <= `TABLESIZE` && `check`[`yyn`] == (`int_t`) `chr`) {",
    "		`yyn` = `table`[`yyn`];",
    "		goto yyreduce;",
    "	}",
    "	if (`errflag` != 0)",
    "		goto yyinrecovery;",
#if defined(YYBTYACC)
    "#if YYBTYACC",
    "",
    "	yynewerrflag = 1;",
    "	goto yyerrhandler;",
    "	goto yyerrlab;	/* redundant goto avoids 'unused label' warning */",
    "",
    "yyerrlab:",
    "	/* explicit YYERROR from an action -- pop the rhs of the rule reduced",
    "	 * before looking for error recovery */",
    "	`stack`.s_mark -= `yym`;",
    "	`state` = *`stack`.s_mark;",
    "	`stack`.l_mark -= `yym`;",
    "",
    "	yynewerrflag = 0;",
    "yyerrhandler:",
    "	while(yyps->save) {",
    "		int ctry;",
    "		yyctx_t *save = yyps->save;",
    "#if `DEBUG`",
    "		if (`debug`)",
    "			fprintf(stderr, \"%s[%d]: ERROR in state %d, CONFLICT BACKTRACKING to state %d, %d tokens\\n\", YYDEBUGSTR, yydepth, `state`, yyps->save->state, (int)(yylvp - yylvals - yyps->save->lexeme));",
    "#endif",
    "		/* Memorize most forward-looking error state in case it's really an error. */",
    "		if (yyerrctx == NULL || yyerrctx->lexeme < yylvp - yylvals) {",
    "			/* Free old saved error context state */",
    "			if (yyerrctx)",
    "				yyFreeState(yyerrctx);",
    "			/* Create and fill out new saved error context state */",
    "			yyerrctx = yyNewState((unsigned)(`stack`.s_mark - `stack`.s_base + 1));",
    "			if (yyerrctx == NULL)",
    "				goto `ENOMEM`;",
    "			yyerrctx->save = yyps->save;",
    "			yyerrctx->state = `state`;",
    "			yyerrctx->errflag = `errflag`;",
    "			yyerrctx->`stack`.s_mark = yyerrctx->`stack`.s_base + (`stack`.s_mark - `stack`.s_base);",
    "			memcpy(yyerrctx->`stack`.s_base, `stack`.s_base, (size_t)(`stack`.s_mark - `stack`.s_base + 1) * sizeof(`int_t`));",
    "			yyerrctx->`stack`.l_mark = yyerrctx->`stack`.l_base + (`stack`.l_mark - `stack`.l_base);",
    "			memcpy(yyerrctx->`stack`.l_base, `stack`.l_base, (size_t)(`stack`.l_mark - `stack`.l_base + 1) * sizeof(`STYPE`));",
    "			yyerrctx->lexeme = (int)(yylvp - yylvals);",
    "		}",
    "		yylvp = yylvals + save->lexeme;",
    "		yylexp = yylexemes + save->lexeme;",
    "		`chr` = `EMPTY`;",
    "		`stack`.s_mark = `stack`.s_base + (save->`stack`.s_mark - save->`stack`.s_base);",
    "		memcpy(`stack`.s_base, save->`stack`.s_base, (size_t)(`stack`.s_mark - `stack`.s_base + 1) * sizeof(`int_t`));",
    "		`stack`.l_mark = `stack`.l_base + (save->`stack`.l_mark - save->`stack`.l_base);",
    "		memcpy(`stack`.l_base, save->`stack`.l_base, (size_t)(`stack`.l_mark - `stack`.l_base + 1) * sizeof(`STYPE`));",
    "		ctry = ++save->ctry;",
    "		`state` = save->state;",
    "		/* We tried shift, try reduce now */",
    "		if ((`yyn` = yyctable[ctry]) >= 0)",
    "			goto yyreduce;",
    "		yyps->save = save->save;",
    "		save->save = NULL;",
    "		yyFreeState(save);",
    "",
    "		/* Nothing left on the stack -- error */",
    "		if (!yyps->save) {",
    "#if `DEBUG`",
    "			if (`debug`)",
    "				fprintf(stderr, \"`debug`[%d,trial]: trial parse FAILED, entering ERROR mode\\n\", yydepth);",
    "#endif",
    "			/* Restore state as it was in the most forward-advanced error */",
    "			yylvp = yylvals + yyerrctx->lexeme;",
    "			yylexp = yylexemes + yyerrctx->lexeme;",
    "			`chr` = yylexp[-1];",
    "			`lval` = yylvp[-1];",
    "			`stack`.s_mark = `stack`.s_base + (yyerrctx->`stack`.s_mark - yyerrctx->`stack`.s_base);",
    "			memcpy(`stack`.s_base, yyerrctx->`stack`.s_base, (size_t)(`stack`.s_mark - `stack`.s_base + 1) * sizeof(`int_t`));",
    "			`stack`.l_mark = `stack`.l_base + (yyerrctx->`stack`.l_mark - yyerrctx->`stack`.l_base);",
    "			memcpy(`stack`.l_base, yyerrctx->`stack`.l_base, (size_t)(`stack`.l_mark - `stack`.l_base + 1) * sizeof(`STYPE`));",
    "			`state` = yyerrctx->state;",
    "			yyFreeState(yyerrctx);",
    "			yyerrctx = NULL;",
    "		}",
    "		yynewerrflag = 1;",
    "	}",
    "	if (yynewerrflag == 0)",
    "		goto yyinrecovery;",
    "#endif /* YYBTYACC */",
#endif			/* defined(YYBTYACC) */
    "",
    "	`error`(ctx, `lval`, \"syntax error\");",
    "",
    "#if !YYBTYACC",
    "	goto yyerrlab;	/* redundant goto avoids 'unused label' warning */",
    "yyerrlab:",
    "#endif",
    "	++`nerrs`;",
    "",
    "yyinrecovery:",
    "	if (`errflag` < 3) {",
    "		`errflag` = 3;",
    "		for(;;) {",
    "			if (((`yyn` = `sindex`[*`stack`.s_mark]) != 0) && (`yyn` += `ERRCODE`) >= 0 && `yyn` <= `TABLESIZE` && `check`[`yyn`] == (`int_t`) `ERRCODE`) {",
    "#if `DEBUG`",
    "				if (`debug`)",
    "					fprintf(stderr, \"%s[%d]: state %d, error recovery shifting to state %d\\n\", YYDEBUGSTR, yydepth, *`stack`.s_mark, `table`[`yyn`]);",
    "#endif",
    "				if (`stack`.s_mark >= `stack`.s_last && `growstack`(yyctx, &`stack`) == `ENOMEM`)",
    "					goto yyoverflow;",
    "				`state` = `table`[`yyn`];",
    "				*++`stack`.s_mark = `table`[`yyn`];",
    "				*++`stack`.l_mark = `lval`;",
    "				goto yyloop;",
    "			}",
    "			else {",
    "#if `DEBUG`",
    "				if (`debug`)",
    "					fprintf(stderr, \"%s[%d]: error recovery discarding state %d\\n\", YYDEBUGSTR, yydepth, *`stack`.s_mark);",
    "#endif",
    "				if (`stack`.s_mark <= `stack`.s_base)",
    "					goto yyabort;",
    "#if defined(YYDESTRUCT_CALL)",
#if defined(YYBTYACC)
    "#if YYBTYACC",
    "				if (!yytrial)",
    "#endif /* YYBTYACC */",
#endif			/* defined(YYBTYACC) */
    "					YYDESTRUCT_CALL(\"error: discarding state\", yystos[*`stack`.s_mark], `stack`.l_mark);",
    "#endif /* defined(YYDESTRUCT_CALL) */",
    "				--`stack`.s_mark;",
    "				--`stack`.l_mark;",
    "			}",
    "		}",
    "	}",
    "	else {",
    "		if (`chr` == `EOF`)",
    "			goto yyabort;",
    "#if `DEBUG`",
    "		if (`debug`) {",
    "			if ((yys = `name`[`TRANSLATE`(`chr`)]) == NULL)",
    "				yys = `name`[`UNDFTOKEN`];",
    "			fprintf(stderr, \"%s[%d]: state %d, error recovery discarding token %d (%s)\\n\", YYDEBUGSTR, yydepth, `state`, `chr`, yys);",
    "		}",
    "#endif",
    "#if defined(YYDESTRUCT_CALL)",
#if defined(YYBTYACC)
    "#if YYBTYACC",
    "		if (!yytrial)",
    "#endif /* YYBTYACC */",
#endif			/* defined(YYBTYACC) */
    "			YYDESTRUCT_CALL(\"error: discarding token\", `chr`, &`lval`);",
    "#endif /* defined(YYDESTRUCT_CALL) */",
    "		`chr` = `EMPTY`;",
    "		goto yyloop;",
    "	}",
    "",
    "yyreduce:",
    "	`yym` = `len`[`yyn`];",
    "#if `DEBUG`",
    "	if (`debug`) {",
    "		fprintf(stderr, \"%s[%d]: state %d, reducing by rule %d (%s)\", YYDEBUGSTR, yydepth, `state`, `yyn`, `rule`[`yyn`]);",
    "#ifdef `STYPE`_TOSTRING",
#if defined(YYBTYACC)
    "#if YYBTYACC",
    "		if (!yytrial)",
    "#endif /* YYBTYACC */",
#endif			/* defined(YYBTYACC) */
    "			if (`yym` > 0) {",
    "				int i;",
    "				fputc('<', stderr);",
    "				for(i = `yym`; i > 0; i--) {",
    "					if (i != `yym`)",
    "						fputs(\", \", stderr);",
    "					fputs(`STYPE`_TOSTRING(yystos[`stack`.s_mark[1 - i]], `stack`.l_mark[1 - i]), stderr);",
    "				}",
    "				fputc('>', stderr);",
    "			}",
    "#endif",
    "		fputc('\\n', stderr);",
    "	}",
    "#endif",
    "	if (`yym` > 0)",
    "		`val` = `stack`.l_mark[1 - `yym`];",
    "	else",
    "		memset(&`val`, 0, sizeof `val`);",
    "",
    "	switch (`yyn`) {",
    0
};

const char *const trailer[] =
{
    "		default:",
    "			break;",
    "	}",
    "	`stack`.s_mark -= `yym`;",
    "	`state` = *`stack`.s_mark;",
    "	`stack`.l_mark -= `yym`;",
    "	`yym` = `lhs`[`yyn`];",
    "	if (`state` == 0 && `yym` == 0) {",
    "#if `DEBUG`",
    "		if (`debug`) {",
    "			fprintf(stderr, \"%s[%d]: after reduction, \", YYDEBUGSTR, yydepth);",
    "#ifdef `STYPE`_TOSTRING",
#if defined(YYBTYACC)
    "#if YYBTYACC",
    "			if (!yytrial)",
    "#endif /* YYBTYACC */",
#endif			/* defined(YYBTYACC) */
    "				fprintf(stderr, \"result is <%s>, \", `STYPE`_TOSTRING(yystos[`FINAL`], `val`));",
    "#endif",
    "			fprintf(stderr, \"shifting from state 0 to final state %d\\n\", `FINAL`);",
    "		}",
    "#endif",
    "		`state` = `FINAL`;",
    "		*++`stack`.s_mark = `FINAL`;",
    "		*++`stack`.l_mark = `val`;",
    "		if (`chr` < 0) {",
#if defined(YYBTYACC)
    "#if YYBTYACC",
    "			do {",
    "				if (yylvp < yylve) {",
    "					/* we're currently re-reading tokens */",
    "					`lval` = *yylvp++;",
    "					`chr` = *yylexp++;",
    "					break;",
    "				}",
    "				if (yyps->save) {",
    "					/* in trial mode; save scanner results for future parse attempts */",
    "					if (yylvp == yylvlim) {	/* Enlarge lexical value queue */",
    "						size_t p = (size_t)(yylvp - yylvals);",
    "						size_t s = (size_t)(yylvlim - yylvals);",
    "",
    "						s += YYLVQUEUEGROWTH;",
    "						if ((yylexemes = (`int_t` *) realloc(yylexemes, s * sizeof(`int_t`))) == NULL)",
    "							goto `ENOMEM`;",
    "						if ((yylvals = (`STYPE` *) realloc(yylvals, s * sizeof(`STYPE`))) == NULL)",
    "							goto `ENOMEM`;",
    "						yylvp = yylve = yylvals + p;",
    "						yylvlim = yylvals + s;",
    "						yylexp = yylexemes + p;",
    "					}",
    "					`GETCHAR`(3, *yylexp);",
    "					*yylvp++ = `lval`;",
    "					yylve++;",
    "					`chr` = *yylexp++;",
    "					break;",
    "				}",
    "				/* normal operation, no conflict encountered */",
    "#endif /* YYBTYACC */",
#endif			/* defined(YYBTYACC) */
    "				`GETCHAR`(4, `chr`);",
#if defined(YYBTYACC)
    "#if YYBTYACC",
    "			} while(0);",
    "#endif /* YYBTYACC */",
#endif			/* defined(YYBTYACC) */
    "			if (`chr` < 0)",
    "				`chr` = `EOF`;",
    "#if `DEBUG`",
    "			if (`debug`) {",
    "				if ((yys = `name`[`TRANSLATE`(`chr`)]) == NULL)",
    "					yys = `name`[`UNDFTOKEN`];",
    "				fprintf(stderr, \"%s[%d]: state %d, reading token %d (%s)\\n\", YYDEBUGSTR, yydepth, `FINAL`, `chr`, yys);",
    "			}",
    "#endif",
    "		}",
    "		if (`chr` == `EOF`)",
    "			goto yyaccept;",
    "		goto yyloop;",
    "	}",
    "	if (((`yyn` = `gindex`[`yym`]) != 0) && (`yyn` += `state`) >= 0 && `yyn` <= `TABLESIZE` && `check`[`yyn`] == (`int_t`) `state`)",
    "		`state` = `table`[`yyn`];",
    "	else",
    "		`state` = `dgoto`[`yym`];",
    "#if `DEBUG`",
    "	if (`debug`) {",
    "		fprintf(stderr, \"%s[%d]: after reduction, \", YYDEBUGSTR, yydepth);",
    "#ifdef `STYPE`_TOSTRING",
#if defined(YYBTYACC)
    "#if YYBTYACC",
    "		if (!yytrial)",
    "#endif /* YYBTYACC */",
#endif			/* defined(YYBTYACC) */
    "			fprintf(stderr, \"result is <%s>, \", `STYPE`_TOSTRING(yystos[`state`], `val`));",
    "#endif",
    "		fprintf(stderr, \"shifting from state %d to state %d\\n\", *`stack`.s_mark, `state`);",
    "	}",
    "#endif",
    "	if (`stack`.s_mark >= `stack`.s_last && `growstack`(yyctx, &`stack`) == `ENOMEM`)",
    "		goto yyoverflow;",
    "	*++`stack`.s_mark = (`int_t`) `state`;",
    "	*++`stack`.l_mark = `val`;",
    "	goto yyloop;",
#if defined(YYBTYACC)
    "#if YYBTYACC",
    "",
    "	/* Reduction declares that this path is valid. Set yypath and do a full parse */",
    "yyvalid:",
    "	if (yypath)",
    "		YYABORT;",
    "	while(yyps->save) {",
    "		yyctx_t *save = yyps->save;",
    "		yyps->save = save->save;",
    "		save->save = yypath;",
    "		yypath = save;",
    "	}",
    "#if `DEBUG`",
    "	if (`debug`)",
    "		fprintf(stderr, \"%s[%d]: state %d, CONFLICT trial successful, backtracking to state %d, %d tokens\\n\", YYDEBUGSTR, yydepth, `state`, yypath->state, (int)(yylvp - yylvals - yypath->lexeme));",
    "#endif",
    "	if (yyerrctx) {",
    "		yyFreeState(yyerrctx);",
    "		yyerrctx = NULL;",
    "	}",
    "	yylvp = yylvals + yypath->lexeme;",
    "	yylexp = yylexemes + yypath->lexeme;",
    "	`chr` = `EMPTY`;",
    "	`stack`.s_mark = `stack`.s_base + (yypath->`stack`.s_mark - yypath->`stack`.s_base);",
    "	memcpy(`stack`.s_base, yypath->`stack`.s_base, (size_t)(`stack`.s_mark - `stack`.s_base + 1) * sizeof(`int_t`));",
    "	`stack`.l_mark = `stack`.l_base + (yypath->`stack`.l_mark - yypath->`stack`.l_base);",
    "	memcpy(`stack`.l_base, yypath->`stack`.l_base, (size_t)(`stack`.l_mark - `stack`.l_base + 1) * sizeof(`STYPE`));",
    "	`state` = yypath->state;",
    "	goto yyloop;",
    "#endif /* YYBTYACC */",
#endif			/* defined(YYBTYACC) */
    "",
    "yyoverflow:",
    "	`error`(ctx, `lval`, \"yacc stack overflow\");",
#if defined(YYBTYACC)
    "#if YYBTYACC",
    "	goto yyabort_nomem;",
    "`ENOMEM`:",
    "	`error`(ctx, `lval`, \"memory exhausted\");",
    "yyabort_nomem:",
    "#endif /* YYBTYACC */",
#endif			/* defined(YYBTYACC) */
    "	yyresult = `RES_NOMEM`;",
    "	goto yyreturn;",
    "",
    "yyabort:",
    "	yyresult = `RES_ABORT`;",
    "	goto yyreturn;",
    "",
    "yyaccept:",
#if defined(YYBTYACC)
    "#if YYBTYACC",
    "	if (yyps->save)",
    "		goto yyvalid;",
    "#endif /* YYBTYACC */",
#endif			/* defined(YYBTYACC) */
    "	yyresult = `RES_DONE`;",
    "",
    "yyreturn:",
    "#if defined(YYDESTRUCT_CALL)",
    "	if (`chr` != `EOF` && `chr` != `EMPTY`)",
    "		YYDESTRUCT_CALL(\"cleanup: discarding token\", `chr`, &`lval`);",
    "",
    "	{",
    "		`STYPE` *pv;",
    "		for(pv = `stack`.l_base; pv <= `stack`.l_mark; ++pv)",
    "			YYDESTRUCT_CALL(\"cleanup: discarding state\", yystos[*(`stack`.s_base + (pv - `stack`.l_base))], pv);",
    "	}",
    "#endif /* defined(YYDESTRUCT_CALL) */",
    "",
#if defined(YYBTYACC)
    "#if YYBTYACC",
    "	if (yyerrctx) {",
    "		yyFreeState(yyerrctx);",
    "		yyerrctx = NULL;",
    "	}",
    "	while(yyps) {",
    "		yyctx_t *save = yyps;",
    "		yyps = save->save;",
    "		save->save = NULL;",
    "		yyFreeState(save);",
    "	}",
    "	while(yypath) {",
    "		yyctx_t *save = yypath;",
    "		yypath = save->save;",
    "		save->save = NULL;",
    "		yyFreeState(save);",
    "	}",
    "#endif /* YYBTYACC */",
#endif			/* defined(YYBTYACC) */
    "	`freestack`(&`stack`);",
    "	return (yyresult);",
    "}",
    0
};

void puts_code(FILE *fp, const char *s);
void putc_code(FILE * fp, int c);
void
write_section(FILE * fp, const char *const section[])
{
    int i;
    const char *s;

    for (i = 0; (s = section[i]) != 0; ++i)
    {
	puts_code(fp, s);putc_code(fp, '\n');
    }
}
